<?php

/*
|---------------------------------------------------------------------------|
| Max Media Manager v0.1                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2004 Awarez Ltd.                                       |
| For contact details, see: http://www.awarez.net/                          |
|                                                                           |
| Copyright (c) 2000-2003 the phpAdsNew developers                          |
| For contact details, see: http://www.phpadsnew.com/                       |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
|---------------------------------------------------------------------------|
$Id: stats-global-advertiser.php 235 2004-05-20 14:50:29Z demian $
*/

    // Include required files
    require ("config.php");
    require ("lib-statistics.inc.php");
    
    // Register input variables
    phpAds_registerGlobal (
         'collapse'
        ,'expand'
        ,'hideinactive'
        ,'listorder'
        ,'orderdirection'
        ,'period'
    );
    
    
    // Security check
    phpAds_checkAccess(phpAds_Admin + phpAds_Agency);
    
    
    // Set default values
    if (empty($period))
        $period = 't';
    if (empty($expand))
        $expand = '';
    
    $tabindex = 1;
    
    /*********************************************************/
    /* HTML framework                                        */
    /*********************************************************/
    
    phpAds_PageHeader("2.1");
    phpAds_ShowSections(array("2.1", "2.4", "2.2"));
    
    /*********************************************************/
    /* Get preferences                                       */
    /*********************************************************/
    
    if (!isset($hideinactive)) {
        if (isset($Session['prefs']['stats-global-advertiser.php']['hideinactive']))
            $hideinactive = $Session['prefs']['stats-global-advertiser.php']['hideinactive'];
        else
            $hideinactive = ($phpAds_config['gui_hide_inactive'] == 't');
    }
    
    if (!isset($listorder)) {
        if (isset($Session['prefs']['stats-global-advertiser.php']['listorder']))
            $listorder = $Session['prefs']['stats-global-advertiser.php']['listorder'];
        else
            $listorder = '';
    }
    
    if (!isset($orderdirection)) {
        if (isset($Session['prefs']['stats-global-advertiser.php']['orderdirection']))
            $orderdirection = $Session['prefs']['stats-global-advertiser.php']['orderdirection'];
        else
            $orderdirection = '';
    }
    
    if (isset($Session['prefs']['stats-global-advertiser.php']['nodes'])) {
        $node_array = explode (",", $Session['prefs']['stats-global-advertiser.php']['nodes']);
    } else {
        $node_array = array();
    }
    
    if (!empty($expand)) {
        if ($expand != 'all') {
            if ($expand == 'none') {
                $node_array = array();
            }
            elseif (!in_array($expand, $node_array)) {
                $node_array[] = $expand;
            }
        }
    }
    
    if (!empty($collapse) && in_array($collapse, $node_array) ) {
        unset($node_array[array_search($collapse, $node_array)]);
    }
        
    /*********************************************************/
    /* Main code                                             */
    /*********************************************************/
    
    // Find which periods we are going to show...
    $totalViews = 0;
    $totalClicks = 0;
    $totalConversions = 0;
    $clientsHidden = 0;
    
    $orderBy = phpAds_getListOrder($listorder, $orderdirection, array('advertiser_name','campaign_name','banner_description'),array('advertiser_id','campaign_id','banner_id'));
    $where = (phpAds_isUser(phpAds_Admin)) ? '' : 'WHERE c.agencyid=' . phpAds_getUserID();

    switch ($period) {
        case 't':    $day = date('Ymd', mktime(0, 0, 0, date('m'), date('d'), date('Y')));
                    $where .= empty($where) ? 'WHERE ' : ' AND ';
                    $where .= "(s.day IS NULL OR s.day = '$day')";
                    break;
                
        case 'y':    $day = date('Ymd', mktime(0, 0, 0, date('m'), date('d') - 1, date('Y')));
                    $where .= empty($where) ? 'WHERE ' : ' AND ';
                    $where .= "(s.day IS NULL OR s.day = '$day')";
                    break;
                
        case 'w':    $day = date('Ymd', mktime(0, 0, 0, date('m'), date('d') - 6, date('Y')));
                    $where .= empty($where) ? 'WHERE ' : ' AND ';
                    $where .= "(s.day IS NULL OR s.day >= '$day')";
                    break;
                
        case 'm':    $timestamp    = date('Ymd', mktime(0, 0, 0, date('m'), 1, date('Y')));
                    $where .= empty($where) ? 'WHERE ' : ' AND ';
                    $where .= "(s.day IS NULL OR s.day >= '$day')";
                    break;
                
        default:    break;
    }
    
    $query = "
        SELECT
            c.clientid AS advertiser_id,
            c.clientname AS advertiser_name,
            m.campaignid AS campaign_id,
            m.campaignname AS campaign_name,
            m.views AS campaign_views,
            m.clicks AS campaign_clicks,
            m.conversions AS campaign_conversions,
            m.active AS campaign_active,
            b.bannerid AS banner_id,
            b.description AS banner_description,
            b.alt AS banner_alt,
            b.storagetype AS banner_storagetype,
            b.active AS banner_active,
            SUM(s.views) AS sum_views,
            SUM(s.clicks) AS sum_clicks,
            SUM(s.conversions) AS sum_conversions
        FROM
            {$phpAds_config['tbl_clients']} AS c
            LEFT JOIN {$phpAds_config['tbl_campaigns']} AS m ON c.clientid=m.clientid
            LEFT JOIN {$phpAds_config['tbl_banners']} AS b ON m.campaignid=b.campaignid
            LEFT JOIN {$phpAds_config['tbl_adstats']} AS s ON b.bannerid=s.bannerid
        $where
        GROUP BY
            banner_id
        $orderBy
    ";
    
    $aStats = array();

    $res = phpAds_dbQuery($query)
        or phpAds_sqlDie();
    while ($row = phpAds_dbFetchArray($res))
    {
        if (empty($row['advertiser_id'])) $row['advertiser_id'] = 0;
        if (empty($row['campaign_id'])) $row['campaign_id'] = 0;
        if (empty($row['banner_id'])) $row['banner_id'] = 0;
        
        $advertiserId = $row['advertiser_id'];
        $campaignId = $row['campaign_id'];
        $bannerId = $row['banner_id'];
        
        if ($advertiserId == '403') {
            $var = $advertiserId;
        }
        
        // Set the advertiser properties
        if (empty($aStats[$advertiserId])) {
            $aStats[$advertiserId] = array(
                'advertiser_id' => $row['advertiser_id'],
                'advertiser_name' => $row['advertiser_name'],
                'advertiser_active' => 'f',
                'expand' => ($expand == 'all' || (in_array('a' . $advertiserId, $node_array) && $expand != 'none'))
            );
        }
        
        // Set the node array if expand == all...
        if (!empty($expand) && $expand == 'all' && !in_array('a'.$advertiserId, $node_array))
            $node_array[] = 'a' . $advertiserId;
            
        if (empty($aStats[$advertiserId]['sum_views'])) {
            $aStats[$advertiserId]['sum_views'] = $row['sum_views'];
        } else {
            $aStats[$advertiserId]['sum_views'] += $row['sum_views'];
        }
        
        if (empty($aStats[$advertiserId]['sum_clicks'])) {
            $aStats[$advertiserId]['sum_clicks'] = $row['sum_clicks'];
        } else {
            $aStats[$advertiserId]['sum_clicks'] += $row['sum_clicks'];
        }
        
        if (empty($aStats[$advertiserId]['sum_conversions'])) {
            $aStats[$advertiserId]['sum_conversions'] = $row['sum_conversions'];
        } else {
            $aStats[$advertiserId]['sum_conversions'] += $row['sum_conversions'];
        }
        
        // Set the campaign properties
        if (empty($aStats[$advertiserId]['campaigns'][$campaignId])) {
            $aStats[$advertiserId]['campaigns'][$campaignId] = array(
                'campaign_id' => $row['campaign_id'],
                'campaign_name' => $row['campaign_name'],
                'campaign_views' => $row['campaign_views'],
                'campaign_clicks' => $row['campaign_clicks'],
                'campaign_conversions' => $row['campaign_conversions'],
                'campaign_active' => $row['campaign_active'],
                'expand' => ($expand == 'all' || (in_array('c' . $campaignId, $node_array) && $expand != 'none'))
            );
        }
        
        // Set the node array if expand == all...
        if (!empty($expand) && $expand == 'all' && !in_array('c'.$campaignId, $node_array))
            $node_array[] = 'c' . $campaignId;
            
        // Flag the advertiser as 'active' if any campaign or banner in the advertiser is active.
        if ($row['campaign_active'] == 't' && $row['banner_active'] == 't')
            $aStats[$advertiserId]['advertiser_active'] = 't';
        
        if (empty($aStats[$advertiserId]['campaigns'][$campaignId]['sum_views'])) {
            $aStats[$advertiserId]['campaigns'][$campaignId]['sum_views'] = $row['sum_views'];
        } else {
            $aStats[$advertiserId]['campaigns'][$campaignId]['sum_views'] += $row['sum_views'];
        }
        
        if (empty($aStats[$advertiserId]['campaigns'][$campaignId]['sum_clicks'])) {
            $aStats[$advertiserId]['campaigns'][$campaignId]['sum_clicks'] = $row['sum_clicks'];
        } else {
            $aStats[$advertiserId]['campaigns'][$campaignId]['sum_clicks'] += $row['sum_clicks'];
        }
        
        if (empty($aStats[$advertiserId]['campaigns'][$campaignId]['sum_conversions'])) {
            $aStats[$advertiserId]['campaigns'][$campaignId]['sum_conversions'] = $row['sum_conversions'];
        } else {
            $aStats[$advertiserId]['campaigns'][$campaignId]['sum_conversions'] += $row['sum_conversions'];
        }
        
        // Set the banner properties
        if (empty($aStats[$advertiserId]['campaigns'][$campaignId]['banners'][$bannerId])) {
            $aStats[$advertiserId]['campaigns'][$campaignId]['banners'][$bannerId] = array(
                'banner_id' => $row['banner_id'],
                'banner_description' => $row['banner_description'],
                'banner_alt' => $row['banner_alt'],
                'banner_storagetype' => $row['banner_storagetype'],
                'banner_active' => $row['banner_active'],
                'sum_views' => $row['sum_views'],
                'sum_clicks' => $row['sum_clicks'],
                'sum_conversions' => $row['sum_conversions']
            );
        }
        
        $totalViews += $row['sum_views'];
        $totalClicks += $row['sum_clicks'];
        $totalConversions += $row['sum_conversions'];
    }
    
    $totalclicks = 0;
    $totalconversions = 0;
    $totalviews = 0;
    
    echo "
        <form action='{$HTTP_SERVER_VARS['PHP_SELF']}'>
        <select name='period' onChange='this.form.submit();' accesskey='$keyList' tabindex='" . $tabindex++ . "'>
            <option value='a'".($period == 'a' ? ' selected' : '').">$strCollectedAll</option>
            <option value='t'".($period == 't' ? ' selected' : '').">$strCollectedToday</option>
            <option value='w'".($period == 'w' ? ' selected' : '').">$strCollected7Days</option>
            <option value='m'".($period == 'm' ? ' selected' : '').">$strCollectedMonth</option>
        </select>
    ";
    phpAds_ShowBreak();
    echo "
        </form>";
    
    if (!empty($aStats)) {
        echo "
        <br><br>
        <table border='0' width='100%' cellpadding='0' cellspacing='0'>
        <tr height='25'>
            <td width='30%'><b>&nbsp;&nbsp;<a href='stats-global-advertiser.php?listorder=name'>{$GLOBALS['strName']}</a>";
        if (($listorder == "name") || ($listorder == "")) {
            if (($orderdirection == "") || ($orderdirection == "down")) {
                echo "
        <a href='stats-global-advertiser.php?orderdirection=up'>
        <img src='images/caret-ds.gif' border='0' alt='' title=''>
        </a>";
            } else {
                echo "
        <a href='stats-global-advertiser.php?orderdirection=down'>
        <img src='images/caret-u.gif' border='0' alt='' title=''>
        </a>";
            }
        }
        echo "
            </b></td>
           <td align='$phpAds_TextAlignRight'><b><a href='stats-global-advertiser.php?listorder=id'>{$GLOBALS['strID']}</a>";
        if ($listorder == "id") {
            if  (($orderdirection == "") || ($orderdirection == "down")) {
                echo "
           <a href='stats-global-advertiser.php?orderdirection=up'>
           <img src='images/caret-ds.gif' border='0' alt='' title=''>
           </a>";
            } else {
                echo "
            <a href='stats-global-advertiser.php?orderdirection=down'>
            <img src='images/caret-u.gif' border='0' alt='' title=''>
            </a>";
            }
        }
        echo "
            </b></td>
           <td align='$phpAds_TextAlignRight'><b>{$GLOBALS['strViews']}</b></td>
           <td align='$phpAds_TextAlignRight'><b>{$GLOBALS['strClicks']}</b></td>
           <td align='$phpAds_TextAlignRight'><b>{$GLOBALS['strCTRShort']}</b></td>
           <td align='$phpAds_TextAlignRight'><b>{$GLOBALS['strConversions']}</b></td>
           <td align='$phpAds_TextAlignRight'><b>{$GLOBALS['strCNVRShort']}</b></td>
        </tr>
        <tr height='1'><td colspan='7' bgcolor='#888888'><img src='images/break.gif' height='1' width='100%'></td></tr>";
        
        $i=0;
        foreach($aStats as $advertiserId => $advertiser) {
            if (!$hideinactive || $advertiser['advertiser_active'] == 't') {
                $bgcolor = ($i++ % 2 == 0) ? " bgcolor='#F6F6F6'" : '';
                echo "
            <tr height='25'$bgcolor>
                <td>";
                if (!empty($advertiser['campaigns'])) {
                    if ($advertiser['expand'] == '1')
                        echo "&nbsp;<a href='stats-global-advertiser.php?period=$period&amp;collapse=a$advertiserId'><img src='images/triangle-d.gif' align='absmiddle' border='0'></a>&nbsp;";
                    else
                        echo "&nbsp;<a href='stats-global-advertiser.php?period=$period&amp;expand=a$advertiserId'><img src='images/$phpAds_TextDirection/triangle-l.gif' align='absmiddle' border='0'></a>&nbsp;";
                }
                else
                    echo "&nbsp;<img src='images/spacer.gif' height='16' width='16'>&nbsp;";
                    
                echo "
                  <img src='images/icon-advertiser.gif' align='absmiddle'>&nbsp;
                  <a href='stats-advertiser-history.php?clientid=$advertiserId'>{$advertiser['advertiser_name']}</a>
                </td>
                <td align='$phpAds_TextAlignRight'>$advertiserId</td>
                <td align='$phpAds_TextAlignRight'>".phpAds_formatNumber($advertiser['sum_views'])."</td>
                <td align='$phpAds_TextAlignRight'>".phpAds_formatNumber($advertiser['sum_clicks'])."</td>
                <td align='$phpAds_TextAlignRight'>".phpAds_buildCTR($advertiser['sum_views'], $advertiser['sum_clicks'])."</td>
                <td align='$phpAds_TextAlignRight'>".phpAds_formatNumber($advertiser['sum_conversions'])."</td>
                <td align='$phpAds_TextAlignRight'>".phpAds_buildCTR($advertiser['sum_clicks'], $advertiser['sum_conversions'])."</td>";
                
                if (!empty($advertiser['campaigns']) && $advertiser['expand']) {
                    foreach ($advertiser['campaigns'] as $campaignId => $campaign) {
                        echo "
            <tr height='1'>
                <td$bgcolor><img src='images/spacer.gif' width='1' height='1'></td>
                <td colspan='7' bgcolor='#888888'><img src='images/break-l.gif' height='1' width='100%'></td>
            </tr>
            <tr height='25'$bgcolor>
                <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
                        
                        if (!empty($campaign['banners'])) {
                            if ($campaign['expand'])
                                echo "<a href='stats-global-advertiser.php?period=$period&amp;collapse=c$campaignId'><img src='images/triangle-d.gif' align='absmiddle' border='0'></a>&nbsp;";
                            else
                                echo "<a href='stats-global-advertiser.php?period=$period&amp;expand=c$campaignId'><img src='images/$phpAds_TextDirection/triangle-l.gif' align='absmiddle' border='0'></a>&nbsp;";
                        }
                        else
                            echo "<img src='images/spacer.gif' height='16' width='16' align='absmiddle'>&nbsp;";
                        
                        
                        if ($campaign['active'] == 't')
                            echo "<img src='images/icon-campaign.gif' align='absmiddle'>&nbsp;";
                        else
                            echo "<img src='images/icon-campaign-d.gif' align='absmiddle'>&nbsp;";
                        
                        echo "
                        <a href='stats-campaign-history.php?clientid=$advertiserId&campaignid=$campaignId'>{$campaign['campaign_name']}
                </td>
                <td align='$phpAds_TextAlignRight'>$campaignId</td>
                <td align='$phpAds_TextAlignRight'>".phpAds_formatNumber($campaign['sum_views'])."</td>
                <td align='$phpAds_TextAlignRight'>".phpAds_formatNumber($campaign['sum_clicks'])."</td>
                <td align='$phpAds_TextAlignRight'>".phpAds_buildCTR($campaign['sum_views'], $campaign['sum_clicks'])."</td>
                <td align='$phpAds_TextAlignRight'>".phpAds_formatNumber($campaign['sum_conversions'])."</td>
                <td align='$phpAds_TextAlignRight'>".phpAds_buildCTR($campaign['sum_clicks'], $campaign['sum_conversions'])."</td>";
                        
                        if (!empty($campaign['banners']) && $campaign['expand']) {
                            foreach ($campaign['banners'] as $bannerId => $banner) {
                                $name = $strUntitled;
                                if (!empty($banner['banner_alt'])) $name = $banner['banner_alt'];
                                if (!empty($banner['banner_description'])) $name = $banner['banner_description'];                        
                                $name = phpAds_breakString ($name, '30');
                                
                                echo "
            <tr height='1'>
                <td$bgcolor><img src='images/spacer.gif' width='1' height='1'></td>
                <td colspan='6' bgcolor='#888888'><img src='images/break-l.gif' height='1' width='100%'></td>
            </tr>
            <tr height='25'$bgcolor>
                <td height='25'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
                                
                                if ($banner['active'] == 't' && $campaign['active'] == 't') {
                                    if ($banner['storagetype'] == 'html')
                                        echo "<img src='images/icon-banner-html.gif' align='absmiddle'>";
                                    elseif ($banner['storagetype'] == 'txt')
                                        echo "<img src='images/icon-banner-text.gif' align='absmiddle'>";
                                    elseif ($banner['storagetype'] == 'url')
                                        echo "<img src='images/icon-banner-url.gif' align='absmiddle'>";
                                    else
                                        echo "<img src='images/icon-banner-stored.gif' align='absmiddle'>";
                                } else {
                                    if ($banner['storagetype'] == 'html')
                                        echo "<img src='images/icon-banner-html-d.gif' align='absmiddle'>";
                                    elseif ($banner['storagetype'] == 'txt')
                                        echo "<img src='images/icon-banner-text-d.gif' align='absmiddle'>";
                                    elseif ($banner['storagetype'] == 'url')
                                        echo "<img src='images/icon-banner-url-d.gif' align='absmiddle'>";
                                    else
                                        echo "<img src='images/icon-banner-stored-d.gif' align='absmiddle'>";
                                }
                                
                                echo "&nbsp;<a href='stats-banner-history.php?clientid=$advertiserId&campaignid=$campaignId&bannerid=$bannerId'>$name</a></td>
                <td align='$phpAds_TextAlignRight'>$bannerId</td>
                <td align='$phpAds_TextAlignRight'>".phpAds_formatNumber($banner['sum_views'])."</td>
                <td align='$phpAds_TextAlignRight'>".phpAds_formatNumber($banner['sum_clicks'])."</td>
                <td align='$phpAds_TextAlignRight'>".phpAds_buildCTR($banner['sum_views'], $banner['sum_clicks'])."</td>
                <td align='$phpAds_TextAlignRight'>".phpAds_formatNumber($banner['sum_conversions'])."</td>
                <td align='$phpAds_TextAlignRight'>".phpAds_buildCTR($banner['sum_clicks'], $banner['sum_conversions'])."</td>";
                            }
                        }
                    }
                }
        
                echo "
            <tr height='1'><td colspan='7' bgcolor='#888888'><img src='images/break.gif' height='1' width='100%'></td></tr>";
            } else {
                $clientsHidden++;
            }
        }
        
        // Total
        echo "
        <tr height='25'$bgcolor>
            <td>&nbsp;&nbsp;<b>$strTotal</b></td>
            <td>&nbsp;</td>
            <td align='$phpAds_TextAlignRight'>".phpAds_formatNumber($totalviews)."</td>
            <td align='$phpAds_TextAlignRight'>".phpAds_formatNumber($totalclicks)."</td>
            <td align='$phpAds_TextAlignRight'>".phpAds_buildCTR($totalviews, $totalclicks)."</td>
            <td align='$phpAds_TextAlignRight'>".phpAds_formatNumber($totalconversions)."</td>
            <td align='$phpAds_TextAlignRight'>".phpAds_buildCTR($totalclicks, $totalconversions)."</td>
        </tr>
        <tr height='1'>
            <td colspan='7' bgcolor='#888888'><img src='images/break.gif' height='1' width='100%'></td>
        </tr>
        <tr>
            <td colspan='4' align='$phpAds_TextAlignLeft' nowrap>";
        
        if ($hideinactive == true) {
            echo "&nbsp;&nbsp;<img src='images/icon-activate.gif' align='absmiddle' border='0'>&nbsp;<a href='stats-global-advertiser.php?period=$period&amp;hideinactive=0'>$strShowAll</a>&nbsp;&nbsp;|&nbsp;&nbsp;$clientsHidden $strInactiveAdvertisersHidden";
        } else {
            echo "&nbsp;&nbsp;<img src='images/icon-hideinactivate.gif' align='absmiddle' border='0'>&nbsp;<a href='stats-global-advertiser.php?period=$period&amp;hideinactive=1'>$strHideInactiveAdvertisers</a>";
        }
        
        echo "
            </td>
            <td colspan='3' align='$phpAds_TextAlignRight' nowrap><img src='images/triangle-d.gif' align='absmiddle' border='0'>&nbsp;<a href='stats-global-advertiser.php?period=$period&amp;expand=all' accesskey='$keyExpandAll'>$strExpandAll</a>&nbsp;&nbsp;|&nbsp;&nbsp;<img src='images/$phpAds_TextDirection/triangle-l.gif' align='absmiddle' border='0'>&nbsp;<a href='stats-global-advertiser.php?period=$period&amp;expand=none' accesskey='$keyCollapseAll'>$strCollapseAll</a>&nbsp;&nbsp;</td>
        </tr>
        </table>
        <br><br>";
    } else {
        echo "
        <br><br><div class='errormessage'><img class='errormessage' src='images/info.gif' width='16' height='16' border='0' align='absmiddle'>$strNoStats</div>";
    }
    
    /*********************************************************/
    /* Store preferences                                     */
    /*********************************************************/
    
    $Session['prefs']['stats-global-advertiser.php']['hideinactive'] = $hideinactive;
    $Session['prefs']['stats-global-advertiser.php']['listorder'] = $listorder;
    $Session['prefs']['stats-global-advertiser.php']['orderdirection'] = $orderdirection;
    $Session['prefs']['stats-global-advertiser.php']['nodes'] = implode (",", $node_array);
    
    phpAds_SessionDataStore();
    
    /*********************************************************/
    /* HTML framework                                        */
    /*********************************************************/
    
    phpAds_PageFooter();
?>