<?php

/*
|---------------------------------------------------------------------------|
| Max Media Manager v0.1                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2004 Awarez Ltd.                                       |
| For contact details, see: http://www.awarez.net/                          |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
|---------------------------------------------------------------------------|
$Id: db.php 375 2004-06-14 13:24:39Z scott $
*/
function MAX_getCacheZoneByZoneId($zoneId)
{
    global $phpAds_config, $phpAds_db_link;
    
    include_once (phpAds_path . "/libraries/deliverycache/cache-{$phpAds_config['delivery_caching']}.inc.php");
    
    $cacheId = "zoneid:$zoneId";
    $cache = phpAds_cacheFetch($cacheId);
    $storeCache = false;
    if ($cache) {
        list($aZone, $cacheTimestamp) = $cache;
        // Check to see if the cache is expired
        if ($cacheTimestamp < time() - $phpAds_config['cacheExpire']) {
            // Connect to the admin DB if not already connected
            if (!$phpAds_db_link) phpAds_dbConnect();
            // Get new zone details
            $aTmpZone = MAX_getZoneByZoneId($zoneId);
            // Check to make sure that we successfully retrieved the banner from cache
            if (!empty($aTmpZone)) {
                $aZone = $aTmpZone;
                $storeCache = true;
            }
        }
    } else {
        // Connect to the admin DB if not already connected
        if (!$phpAds_db_link) phpAds_dbConnect();
        // Get new zone details
        $aZone = MAX_getZoneByZoneId($zoneId);
        if (!empty($aZone)) {
            $storeCache = true;
        }
    }
    
    // Check to see if we need to store the zone back to cache
    if ($storeCache) {
        // Write the zone back to cache
        $cache = array ($aZone, time());
        phpAds_cacheStore ($cacheId, $cache);
    }        

    return $aZone;
}
function MAX_getCacheBannerByBannerId($bannerId)
{
    global $phpAds_config, $phpAds_db_link;
    
    include_once (phpAds_path . "/libraries/deliverycache/cache-{$phpAds_config['delivery_caching']}.inc.php");
    $cacheId = "bannerid:$bannerId";
    $cache = phpAds_cacheFetch($cacheId);
    $storeCache = false;
    if ($cache) {
        list($aBanner, $cacheTimestamp) = $cache;
        // Check to see if the cache is expired
        if ($cacheTimestamp < time() - $phpAds_config['cacheExpire']) {
            // Connect to the admin DB if not already connected
            if (!$phpAds_db_link) phpAds_dbConnect();
            // Get new banner details
            $aTmpBanner = MAX_getBannerByBannerId($bannerId);
            // Check to make sure that we successfully retrieved the banner from cache
            if (!empty($aTmpBanner)) {
                $aBanner = $aTmpBanner;
                $storeCache = true;
            }
        }
    } else {
        // Connect to the admin DB if not already connected
        if (!$phpAds_db_link) phpAds_dbConnect();
        // Get new banner details
        $aBanner = MAX_getBannerByBannerId($bannerId);
        if (!empty($aBanner)) {
            $storeCache = true;
        }
    }
    
    // Check to see if we need to store the banner back to cache
    if ($storeCache) {
        // Write the banner back to cache
        $cache = array ($aBanner, time());
        phpAds_cacheStore ($cacheId, $cache);
    }        

    return $aBanner;
}

function MAX_getZoneByZoneId($zoneId)
{
    global $phpAds_config;
    
    $query = "
        SELECT
            z.zoneid AS zoneid,
            z.affiliateid AS affiliateid,
            z.zonename AS zonename,
            z.description AS description,
            z.delivery AS delivery,
            z.zonetype AS zonetype,
            z.what AS what,
            z.width AS width,
            z.height AS height,
            z.chain AS chain,
            z.prepend AS prepend,
            z.append AS append,
            z.appendtype AS appendtype
        FROM
            {$phpAds_config['tbl_zones']} AS z
        WHERE
            z.zoneid=$zoneId
    ";
    
    $res = phpAds_dbQuery($query);
    $row = phpAds_dbFetchArray($res);
    
    $aZone = false;
    if (!empty($row))
        $aZone = $row;
        
    return $aZone;
}

function MAX_getBannerByBannerId($bannerId)
{
    global $phpAds_config;
    
    $query = "
        SELECT
            b.bannerid AS bannerid,
            b.campaignid AS campaignid,
            b.active AS active,
            b.priority AS priority,
            b.contenttype AS contenttype,
            b.pluginversion AS pluginversion,
            b.storagetype AS storagetype,
            b.filename AS filename,
            b.imageurl AS imageurl,
            b.htmltemplate AS htmltemplate,
            b.htmlcache AS htmlcache,
            b.width AS width,
            b.height AS height,
            b.weight AS weight,
            b.seq AS seq,
            b.target AS target,
            b.url AS url,
            b.alt AS alt,
            b.status AS status,
            b.keyword AS keyword,
            b.bannertext AS bannertext,
            b.description AS description,
            b.autohtml AS autohtml,
            b.adserver AS adserver,
            b.block AS block,
            b.capping AS capping,
            b.session_capping AS session_capping,
            b.compiledlimitation AS compiledlimitation,
            b.append AS append,
            b.appendtype AS appendtype,
            b.bannertype AS bannertype,
            b.alt_filename AS alt_filename,
            b.alt_imageurl AS alt_imageurl,
            b.alt_contenttype AS alt_contenttype
        FROM
            {$phpAds_config['tbl_banners']} AS b
        WHERE
            b.bannerid=$bannerId
    ";
    
    $res = phpAds_dbQuery($query);
    $row = phpAds_dbFetchArray($res);
    
    $aBanner = false;
    if (!empty($row))
        $aBanner = $row;
        
    return $aBanner;
}

function MAX_setBannerByBannerId($bannerId, $aParameters)
{
    global $phpAds_config;
    
    $set = array();
    foreach ($aParameters as $name => $value) {
        $set[] = "$name='$value'";
    }
    $set = implode(',', $set);
    $query = "
        UPDATE {$phpAds_config['tbl_banners']}
        SET
            $set
        WHERE
            bannerid=$bannerId
    ";
    $res = phpAds_dbQuery($query)
        or phpAds_sqlDie();
    
    return $bannerId;
}

function MAX_AddBanner($aParameters)
{
    global $phpAds_config;
    
    $names = array();
    $values = array();
    foreach ($aParameters as $name => $value) {
        $names[] = $name;
        $values[] = "'$value'";
    }
    $names = implode(',', $names);
    $values = implode(',', $values);
    
    $query = "
        INSERT INTO {$phpAds_config['tbl_banners']}
            ($names)
        VALUES
            ($values)
    ";
    $res = phpAds_dbQuery($query)
        or phpAds_sqlDie();
    
    $bannerId = phpAds_dbInsertID();
    return $bannerId;
}
?>